import { merge } from './merge';

const sample = {
  foo: 'bar',
  bar: 'bar'
};

test('merge', () => {
  expect(merge(sample)({ bar: 'baz' })).toEqual({
    foo: 'bar',
    bar: 'baz'
  });
});

/**
 * https://github.com/selfrefactor/rambda/issues/77
 */
test('when undefined or null instead of object', () => {
  expect(merge(null, undefined)).toEqual({});
  expect(merge(sample, null)).toEqual(sample);
  expect(merge(sample, undefined)).toEqual(sample);
  expect(merge(undefined, sample)).toEqual(sample);
});